/*
	WinMenu DLL v0.1
	by ClickHeRe
	panodude@videotron.ca

	This DLL lets the user set some window menus on a @window in mIRC

*/
#pragma check_stack(off)
#pragma comment(linker,"/OPT:NOWIN98")

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>

// alias to define an External DLL Command
#define mIRC(x) int __stdcall WINAPI x(HWND mWnd,HWND aWnd,char *data,char*,BOOL,BOOL)
// alias to define a WNDPROC function
#define Proc(x) LRESULT CALLBACK x(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
#define ret(x) { strcpy(data,x); strcat(data,"\0"); return 3; }


#define NBMAX 20

// ##################################################################################################

// Global Vars
HANDLE hFileMap;
LPSTR mData;
char signal[900];
HWND mIRC_hwnd;

// ##################################################################################################
// structures
struct WINSTRUCT
{
	HWND Whwnd;
	WNDPROC OldProc;
	char winname[900];
}; 
struct WINSTRUCT Window[NBMAX];

// default Load DLL structure
typedef struct {
    DWORD  mVersion;
    HWND   mHwnd;
    BOOL   mKeep;
} LOADINFO;


// ##################################################################################################


void FreeWinRessources(int i) {
	// give back old winproc to dialog
  SetWindowLong(Window[i].Whwnd,GWL_WNDPROC,(LONG)Window[i].OldProc);
	// reset window HWND for other mark process
  Window[i].Whwnd = 0;
}

void Signal() {	
	wsprintf(mData,"//.signal -n WMENU %s",signal);
	SendMessage(mIRC_hwnd, WM_USER + 200,0,0);
}

// if ID is in the valid 1 - 500 range
bool ValID (int ID) { 
  if (ID > 0 && ID < 500) return TRUE;
	else return FALSE;
}

// if ID element existes, the HMENU handle is returned, else 0
HMENU IsID (HMENU hmenu, UINT ID) {

  if (!IsMenu(hmenu)) { return 0; }
	
	HMENU hm = 0, hmenu2;
  int nmenu = GetMenuItemCount(hmenu);
	int i = 0;

	while (i < nmenu) {

		if (GetMenuItemID(hmenu,i) == ID) {
		  hm = hmenu;
			break;
		}
		else if (hmenu2 = GetSubMenu(hmenu,i)) {
       hm = IsID(hmenu2,ID);
			 if (hm > 0) {
				 break;
			 }
		}

		i++;
	}
	return hm;
}

// ##################################################################################################
// Load DLL command
void WINAPI LoadDll(LOADINFO* load)
{
	hFileMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,4096,"mIRC");     
  mData = (LPSTR)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0);
  mIRC_hwnd = load->mHwnd;
}

// Unload DLL command
int WINAPI UnloadDll(int timeout)
{
	if (!timeout)
  { 

		int i=0,j=0;
		while (i < NBMAX) 
		{
			if (Window[i].Whwnd) FreeWinRessources(i);		   
			i++;
		}

		UnmapViewOfFile(mData);
		CloseHandle(hFileMap);
		return 1;
	}
  else return 0;
}

// ##################################################################################################
// Dialog Procedure Callback

Proc(WinProc)
{
	int i = 0,j = 0;
	// find which window was handle
	while(Window[i].Whwnd != hwnd) i++;

	switch(uMsg)
	{
		// free ressources assciated with window
		case WM_DESTROY:
		{
			FreeWinRessources(i);
		}
		break;

		case WM_COMMAND:
		{
			int ID = (UINT) wParam - 20000;
			wsprintf(signal,"%s %d",Window[i].winname, ID);
			Signal();
		}
		break;
	}
	return CallWindowProc(Window[i].OldProc,hwnd,uMsg,wParam,lParam);
}

// ##################################################################################################
// External DLL Commands
mIRC(Version) 
{
	ret("WinMenu DLL v0.1 by ClickHeRe 2003 - http://metax.scriptsdb.org");
}

// Command qui popup le menu d'une @window mIRC o l'on veut

// Commande pour marquer une fentre
mIRC(WMMark) {

	int i = 0;
	HWND hwnd = (HWND) atoi(strtok(data," "));
	
	// check if window handle exists
	if (!IsWindow(hwnd)) {
	 ret("ERROR Mark: invalid window");
	}
	// find if window was already marked
	while (i < NBMAX) {
	  if (Window[i].Whwnd == hwnd) break;
	  else i++;
	}  

  if (i != NBMAX) {
		ret("ERROR Mark: window is already marked");
	}
	// find first non used ressource window
	i = 0;
	while (Window[i].Whwnd && i < NBMAX) i++;
	if (i == NBMAX) {
		wsprintf(data,"ERROR Mark: %d windows are already marked.",NBMAX);
		return 3;
	}
	// Mark Window
	Window[i].Whwnd = hwnd;
	// Override Old Window Procedure
	Window[i].OldProc = (WNDPROC)SetWindowLong(Window[i].Whwnd,GWL_WNDPROC,(LONG)WinProc);
	// store window name data
	strcpy(Window[i].winname,strtok(NULL,""));
  
	ret("S_OK window marked.");
}

mIRC(WMCreateMenuBar) {

  HMENU hmenu;
	if (!(hmenu = CreateMenu())) {  
		ret("S_ERROR Create MenuBar Failed.");
	}
	else {
		wsprintf(data,"S_OK %d",(UINT) hmenu);
		return 3;
	}
}

mIRC(WMCreateSubMenu) { 
  
	HMENU hsubmenu;
	if (!(hsubmenu = CreatePopupMenu())) {
		ret("S_ERROR Submenu Creation Failed");
	}
	else { 
		wsprintf(data,"S_OK %d",(UINT) hsubmenu);
		return 3;
	}
}

mIRC(WMSetItem) {
	
	HMENU hmenu;
	UINT ID, style, styles; 
	char mhwnd[20];
	char mID[10];
	char mop[5];
	char params[500];
	// extract window hwnd
	wsprintf(mhwnd,"%s",strtok(data,">"));
	// extract Control ID
	wsprintf(mID,"%s",strtok(NULL," "));
  // extract Option
	wsprintf(mop,"%s",strtok(NULL," "));
	// extract Text parameters
	wsprintf(params,"%s",strtok(NULL," "));
	// convert hwnd & ID to numbers
  hmenu = (HMENU) atoi(mhwnd);

	if (!IsMenu(hmenu)) {
		ret("S_ERROR Invalid Menu Handle");
	}

  if (!strcmp(params,"-")) {
		if (!AppendMenu(hmenu,MF_SEPARATOR,0,"")) {
			ret("S_ERROR Menu Separator Failed");
		}
	}
	else {

		ID = (UINT) atoi(mID);
		if (!ValID(ID)) { 
			ret("S_ERROR Invalid ID");
		}
		ID += 20000;

		style = (UINT) atoi(mop);
	  if (style == 3) { 
	   styles = MF_STRING | MF_CHECKED | MF_GRAYED;
		}
		else if (style == 2) {
			styles = MF_STRING | MF_CHECKED;
		}
		else if (style == 1) {
			styles = MF_STRING | MF_GRAYED;
		}
		else { 
			styles = MF_STRING;
		}
		if (!AppendMenu(hmenu,styles,ID,params)) {
			ret("S_ERROR Menu Item Failed");
		}
	}
	ret("S_OK Menu Item Created");
}

mIRC(WMSetSubMenu) { 
  
	HMENU hmenu;
	HMENU hsmenu; 
	char mhwnd[20];
	char hsmenuID[10];
	char params[500];
	// extract window hwnd
	wsprintf(mhwnd,"%s",strtok(data,">"));
	// extract Control ID
	wsprintf(hsmenuID,"%s",strtok(NULL," "));
	// extract Tooltip parameters
	wsprintf(params,"%s",strtok(NULL," "));
	// convert hwnd & ID to numbers
  hmenu = (HMENU) atoi(mhwnd);

	if (!IsMenu(hmenu)) {
		ret("S_ERROR Invalid Menu Handle");
	}

	hsmenu = (HMENU) atoi(hsmenuID);

	if (!IsMenu(hsmenu)) { 
	  ret("S_ERROR Invalid SubMenu Handle");
	}
  
  if (!AppendMenu(hmenu,MF_STRING | MF_POPUP,(UINT) hsmenu,params)) {
		ret("S_ERROR SubMenu Link Failed");
	}
	ret("S_OK SubMenu Link Created");
}

mIRC(WMSetMenu) { 
  
	HWND hwnd;
	HMENU hmenu; 
	char whwnd[20];
	char hID[10];
	// extract window hwnd
	wsprintf(whwnd,"%s",strtok(data,">"));
	// extract Control ID
	wsprintf(hID,"%s",strtok(NULL,""));
	// extract Tooltip parameters
	hmenu = (HMENU) atoi(hID);
	hwnd = (HWND) atoi(whwnd);

  if (!IsWindow(hwnd)) {
		ret("S_ERROR Invalid Window Hwnd");
	}

	int i = 0;
	while (i < NBMAX) {
	  if (Window[i].Whwnd == hwnd) break;
	  else i++; 
  }  
  if (i == NBMAX) {
	  ret("ERROR WinMenu: window must be marked first");
	}

	if (!IsMenu(hmenu)) { 
	  ret("S_ERROR Invalid Menu Hwnd");
	} 

	SetMenu(hwnd,hmenu);
	
	if (!DrawMenuBar(hwnd)) { 
	  ret("S_ERROR Menu Bar Drawing Error.");
	}
   
	ret("S_OK Window Menu Set");
}

mIRC(WMIsMenuID) {

  HWND hwnd;
	HMENU hmenu, hmenufind;
	UINT ID;
	char mhwnd[20];
	char mID[10];
	// extract window hwnd
	wsprintf(mhwnd,"%s",strtok(data,">"));
	// extract Control ID
	wsprintf(mID,"%s",strtok(NULL," "));
  
	// convert hwnd & ID to numbers
  hwnd = (HWND) atoi(mhwnd);

  if (!IsWindow(hwnd)) {
		ret("S_ERROR Invalid Window Hwnd");
	}

	hmenu = GetMenu(hwnd);

	if (!IsMenu(hmenu)) {
		ret("S_ERROR Invalid Menu Handle");
	}

	ID = (UINT) atoi(mID);
	if (!ValID(ID)) { 
	  ret("S_ERROR Invalid ID");
	}
	
	ID += 20000;

  hmenufind = IsID(hmenu,ID);

	if (hmenufind > 0) {
	  ret("S_OK $true");	
	}
	else {
		ret("S_OK $false");
	}
}

mIRC(WMMenuIDStyle) {

	HWND hwnd;
	HMENU hmenu, hmenufind;
	UINT ID, style;
	char mhwnd[20];
	char mID[10];
	char mop[5];
	// extract window hwnd
	wsprintf(mhwnd,"%s",strtok(data,">"));
	// extract Control ID
	wsprintf(mID,"%s",strtok(NULL," "));
	// extract Option
	wsprintf(mop,"%s",strtok(NULL," "));
	 
	// convert hwnd & ID to numbers
  hwnd = (HWND) atoi(mhwnd);

  if (!IsWindow(hwnd)) {
		ret("S_ERROR Invalid Window Hwnd");
	}

	hmenu = GetMenu(hwnd);

	if (!IsMenu(hmenu)) {
		ret("S_ERROR Invalid Menu Handle");
	}

	ID = (UINT) atoi(mID);

	if (!ValID(ID)) { 
	  ret("S_ERROR Invalid ID");
	}
	
	ID += 20000;

	hmenufind = IsID(hmenu,ID);

	if (hmenufind > 0) {

		style = (UINT) atoi(mop);
    if (style == 3) { 
	    CheckMenuItem(hmenufind,ID,MF_CHECKED);
			EnableMenuItem(hmenufind,ID,MF_GRAYED);
		}
		else if (style == 2) {
			CheckMenuItem(hmenufind,ID,MF_CHECKED);
			EnableMenuItem(hmenufind,ID,MF_ENABLED);
		}
		else if (style == 1) {
			CheckMenuItem(hmenufind,ID,MF_UNCHECKED);
			EnableMenuItem(hmenufind,ID,MF_GRAYED);
			
		}
		else { 
			CheckMenuItem(hmenufind,ID,MF_UNCHECKED);
			EnableMenuItem(hmenufind,ID,MF_ENABLED);
		}
	  ret("S_OK");	
	}
	else {
		ret("S_ERROR Invalid Menu ID");
	}
}